"""Sequential Logic."""

from .design import DesignError, Float, Module, Packed, Unpacked
from .expr import (
    EQ,
    GE,
    GT,
    ITE,
    LE,
    LT,
    NE,
    Adc,
    Add,
    And,
    Cat,
    Div,
    Expr,
    GetAttr,
    GetItem,
    Impl,
    Land,
    Lor,
    Lrot,
    Lsh,
    Lxor,
    Mod,
    Mul,
    Mux,
    Neg,
    Ngc,
    Not,
    Or,
    Rep,
    Rrot,
    Rsh,
    Sbc,
    Srsh,
    Sub,
    Sxt,
    Uand,
    Uor,
    Uxor,
    Xor,
    Xt,
)

__all__ = [
    # design
    "DesignError",
    "Module",
    "Packed",
    "Unpacked",
    "Float",
    # expr
    "Expr",
    # expr.bitwise
    "Not",
    "Or",
    "And",
    "Xor",
    "Impl",
    "ITE",
    "Mux",
    # expr.logical
    "Lor",
    "Land",
    "Lxor",
    # expr.unary
    "Uor",
    "Uand",
    "Uxor",
    # expr.arithmetic
    "Add",
    "Adc",
    "Sub",
    "Sbc",
    "Neg",
    "Ngc",
    "Mul",
    "Div",
    "Mod",
    "Lsh",
    "Rsh",
    "Srsh",
    # expr.word
    "Xt",
    "Sxt",
    "Lrot",
    "Rrot",
    "Cat",
    "Rep",
    # expr.predicate
    "EQ",
    "NE",
    "GT",
    "GE",
    "LT",
    "LE",
    # expr.getters
    "GetItem",
    "GetAttr",
]
